<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.9
  $Source$
  $Revision: 3125 $
  $Author: gaugau $
  $Date: 2006-06-16 08:48:03 +0200 (Fr, 16 Jun 2006) $
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 1);

require_once 'bridge/udb_base.inc.php';
class dcforum_udb extends core_udb {

	function dcforum_udb()
	{
		global $BRIDGE;
		
		$this->boardurl = 'http://www.legacybb.com/dc/';
		
		$this->multigroups = 0;
		
		// Database connection settings
		$this->db = array(
			'name' => 'lovflags',
			'host' => 'www.prusak.net',
			'user' => 'lovflags',
			'password' => 'lovflags',
			'prefix' => 'dc'
		);
		
		// Board table names
		$this->table = array(
			'users' => 'user',
			'groups' => 'group',
			'sessions' => 'session',
			'usergroups' => 'group'
		);

		// Derived full table names
		$this->usertable = $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  $this->db['prefix'] . $this->table['groups'];
		$this->sessionstable =   $this->db['prefix'] . $this->table['sessions'];
		$this->usergroupstable = $this->db['prefix'] . $this->table['usergroups'];
		
		// Table field names
		$this->field = array(
			'username' => 'username', // name of 'username' field in users table
			'user_id' => 'id', // name of 'id' field in users table
			'password' => 'password', // name of 'password' field in users table
			'email' => 'email', // name of 'email' field in users table
			'regdate' => 'reg_date', // name of 'registered' field in users table
			'active' => 'status', // is user account active?
			'lastvisit' => 'last_date', // name of 'location' field in users table
			'location' => 'pf', // name of 'location' field in users table
			'website' => 'ph', // name of 'website' field in users table
			'usertbl_group_id' => 'g_id', // name of 'group id' field in users table
			'grouptbl_group_id' => 'id', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'name', // name of 'group name' field in groups table
			'session_user_id' => 'u_id' //Session User ID
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => '/dcboard.php?az=register',
			'editusers' => '/dcboard.php?az=user',
			'edituserprofile' => "/dcboard.php?az=user&saz=change_profile",
		);
		
		// Group ids - admin and guest only.
		$this->admingroups[] = 99;
		$this->guestgroup = -1;
		
		$this->use_post_based_groups = 1;

		// Use a special function to collect groups for cpg groups table
		$this->group_overrride = 0;
		
		// Cookie settings - used in following functions only
		$this->cookie_name = 'dccookie';
		
		// Connect to db
		$this->connect();
	}

	function collect_groups()
	{
		$sql ="SELECT * FROM {$this->groupstable}";
	
		$result = cpg_db_query($sql, $this->link_id);
		
		$udb_groups = array(1 =>'Administrators', 2=> 'Registered', 3=>'Guests', 4=> 'Banned');
			
		while ($row = mysql_fetch_assoc($result))
		{
			$udb_groups[$row[$this->field['grouptbl_group_id']]+100] = utf_ucfirst(utf_strtolower($row[$this->field['grouptbl_group_name']]));
		}

		return $udb_groups;
		
	}
	// definition of how to extract id, name, group from a session cookie
	function session_extraction()
	{
		if (isset($_COOKIE[$this->cookie_name])) {

			$str = base64_decode($_COOKIE[$this->cookie_name]);
			$tmparr = explode('&',$str);
			while(list($key,$value) = each($tmparr)) {
			   $kv_array = explode('=',$value);
			   $outarr[$kv_array['0']] = $kv_array['1'];
			}
			$session_key = $outarr[dcsi];
			$session_id = $outarr[dcsk];

			$sql = "SELECT {$this->field['session_user_id']} AS user_id, g_id FROM {$this->sessionstable} where id = '$session_id' and s_id = '$session_key'";

			$result = cpg_db_query($sql, $this->link_id);

			if (mysql_num_rows($result)){
				$row = mysql_fetch_array($result);
				$this->userlevel = $row['g_id'];
				return $row;
			} else {
			    return false;
			}
		}
	}


	// definition of how to extract an id and password hash from a cookie
	function cookie_extraction()
	{
	    return false;
	}

	
	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password;
	}


	function login_page()
	{
		$this->redirect("dcboard.php?az=login");
	}

	function logout_page()
	{
		$this->redirect("dcboard.php?az=logout");
	}

	function authenticate()
	{
		global $USER_DATA;
		
		$USER_DATA['groups'] = array();
		
		if (!($auth = $this->session_extraction()) && !($auth = $this->cookie_extraction())) {
			$this->load_guest_data();
		} else {
			list ($id, $cookie_pass) = $auth;
			$f = $this->field;
		
			$sql = "SELECT u.{$f['user_id']} AS id, u.{$f['username']} AS username, u.{$f['password']} AS password, u.{$f['usertbl_group_id']}+100 AS group_id ".
			"FROM {$this->usertable} AS u INNER JOIN {$this->groupstable} AS g ON u.{$f['usertbl_group_id']}=g.{$f['grouptbl_group_id']} ".
			"WHERE u.{$f['user_id']}='$id'";

			$result = cpg_db_query($sql, $this->link_id);
			if (mysql_num_rows($result)){
				$row = mysql_fetch_assoc($result);
				mysql_free_result($result);
				$this->load_user_data($row);
			} else {
				$this->load_guest_data();
			}
		}

		$user_group_set = '(' . implode(',', $USER_DATA['groups']) . ')';

		$USER_DATA = array_merge($USER_DATA, $this->get_user_data($USER_DATA['groups'][0], $USER_DATA['groups'], $this->guestgroup));

		if ($USER_DATA['groups'][0] > 101 ){
			$USER_DATA['can_create_albums'] = 1;
			$USER_DATA['can_send_ecards'] = 1;
			$USER_DATA['can_rate_pictures'] = 1;
			$USER_DATA['can_post_comments'] = 1;
			$USER_DATA['can_upload_pictures'] = 1;
		}

		// For error checking
		$CONFIG['TABLE_USERS'] = '**ERROR**';
		
		define('USER_ID', $USER_DATA['user_id']);
		define('USER_NAME', addslashes($USER_DATA['user_name']));
		define('USER_GROUP', $USER_DATA['group_name']);
		define('USER_GROUP_SET', $user_group_set);
		define('USER_IS_ADMIN', $USER_DATA['has_admin_access']);
		define('USER_CAN_SEND_ECARDS', (int)$USER_DATA['can_send_ecards']);
		define('USER_CAN_RATE_PICTURES', (int)$USER_DATA['can_rate_pictures']);
		define('USER_CAN_POST_COMMENTS', (int)$USER_DATA['can_post_comments']);
		define('USER_CAN_UPLOAD_PICTURES', (int)$USER_DATA['can_upload_pictures']);
		define('USER_CAN_CREATE_ALBUMS', (int)$USER_DATA['can_create_albums']);
		define('USER_UPLOAD_FORM', (int)$USER_DATA['upload_form_config']);
		define('CUSTOMIZE_UPLOAD_FORM', (int)$USER_DATA['custom_user_upload']);
		define('NUM_FILE_BOXES', (int)$USER_DATA['num_file_upload']);
		define('NUM_URI_BOXES', (int)$USER_DATA['num_URI_upload']);

		$myUserID = $USER_DATA['user_id'];
		$sql  = "INSERT INTO dclog VALUES('','$myUserID','Viewing Gallery','','$REMOTE_ADDR',NOW())";
		cpg_db_query($sql);


		$this->session_update();
	}

	// Edit user profile
	function edit_profile($uid)
	{
	       $this->redirect($this->page['edituserprofile']);
	}

	// View user profile
	function view_profile($uid)
	{
		$this->redirect($this->page['edituserprofile']);
	}

	function synchronize_groups()
	{
		global $CONFIG ;
		
		if ($this->use_post_based_groups){
			if ($this->group_overrride){
				$udb_groups = $this->collect_groups();
			} else {
				$sql = "SELECT * FROM {$this->groupstable} WHERE {$this->field['grouptbl_group_name']} <> ''";
		
				$result = cpg_db_query($sql, $this->link_id);
		
				$udb_groups = array();
				
				while ($row = mysql_fetch_assoc($result))
				{
					$udb_groups[$row[$this->field['grouptbl_group_id']]+100] = $row[$this->field['grouptbl_group_name']];
				}
			}
		} else {
			$udb_groups = array(1 =>'Administrators', 2=> 'Registered', 3=>'Guests', 4=> 'Banned');
		}
		
		$result = cpg_db_query("SELECT group_id, group_name FROM {$CONFIG['TABLE_USERGROUPS']} WHERE 1");
		
		while ($row = mysql_fetch_array($result)) {
			$cpg_groups[$row['group_id']] = $row['group_name'];
		}
		
		mysql_free_result($result);
		
		// Scan Coppermine groups that need to be deleted
		foreach($cpg_groups as $c_group_id => $c_group_name) {
			if ((!isset($udb_groups[$c_group_id]))) {
				cpg_db_query("DELETE FROM {$CONFIG['TABLE_USERGROUPS']} WHERE group_id = '" . $c_group_id . "' LIMIT 1");
				unset($cpg_groups[$c_group_id]);
			}
		}
		
		// Scan udb groups that need to be created inside Coppermine table
		foreach($udb_groups as $i_group_id => $i_group_name) {
			if ((!isset($cpg_groups[$i_group_id]))) {
				// add admin info  
				$admin_access = in_array($i_group_id-100, $this->admingroups) ? '1' : '0';
				cpg_db_query("INSERT INTO {$CONFIG['TABLE_USERGROUPS']} (group_id, group_name, has_admin_access) VALUES ('$i_group_id', '" . addslashes($i_group_name) . "', '$admin_access')");
				$cpg_groups[$i_group_id] = $i_group_name;
			}
		}
		
		// Update Group names
		foreach($udb_groups as $i_group_id => $i_group_name) {
			if ($cpg_groups[$i_group_id] != $i_group_name) {
				cpg_db_query("UPDATE {$CONFIG['TABLE_USERGROUPS']} SET group_name = '" . addslashes($i_group_name) . "' WHERE group_id = '$i_group_id' LIMIT 1");
			}
		}
		// fix admin grp
		if (!$this->use_post_based_groups) cpg_db_query("UPDATE {$CONFIG['TABLE_USERGROUPS']} SET has_admin_access = '1' WHERE group_id = '199' LIMIT 1");
	}

}

// and go !
$cpg_udb = new dcforum_udb;
?>
